(load "c:/archiai/lsp/ai")
(load  "c:/archiai/lsp/graphic")


;;;***********	
(defun c:ins_col (  / x_off y_off x_scale y_scale angs pt flag_init
			os
			anglst x_scalelst y_scalelst x_offlst y_offlst
		)
	(setq os (getvar "osmode"))
	(setvar "osmode" 0)
	(setq x_offlst (list 0 50 100 150 200 250 300 350)
		y_offlst  (list 0 50 100 150 200 250 300 350)
		x_scalelst (list 200 300 400 500 600 700 800 900 1000 1200)
		y_scalelst (list 200 300 400 500 600 700 800 900 1000 1200)
		anglst (list 0 90 180 270)
	)
	(setq flag_init nil)
	;;
	(setq t_lst '(	"x_scale"
			"y_scale"
			"x_off"
			"y_off"
			"angs"
			"left"
			"up"
			"get_point"
			"comfirm"
			"accept"
			))
	(setq a_lst '(	"(get_value_col 1 $value)"
			"(get_value_col 2 $value)"
			"(get_value_col 3 $value)"
			"(get_value_col 4 $value)"
			"(get_value_col 5 $value)"
			"(get_value_col 6 $value)"
			"(get_value_col 7 $value)"
			"(done_dialog 9)"
			"(wh_col 10)" 
			"(done_dialog 1)" ))
	;;

	(ldcl_ai "/archiai/dcl/ai" "insert_col" t_lst a_lst
	init_col wh_col)
	(if left nil (setq x_off (* -1.0 x_off)))
	(if up nil (setq y_off (* -1.0 y_off)))
	(setq temp (list x_off y_off 0.0))
	(if (and pt angs x_scale y_scale x_off y_off)
	(progn
	(set_layer "column")
	
	(command "insert" "column" (mapcar '+ pt temp) 
		x_scale y_scale angs)))
	(setvar "osmode" os)
	(gc)
	(terpri)
	)
(defun init_col()
	(if flag_init
	
	
	(progn
		(set_tile "x_scale" (itoa (find_place X_scale x_scalelst)))
		(set_tile "y_scale" (itoa (find_place y_scale y_scalelst)))
		(set_tile "x_off" (itoa (find_place X_off x_offlst)))
		(set_tile "y_off" (itoa (find_place y_off y_offlst)))
		(set_tile "angs" (itoa (find_place angs anglst)))
		(if left (set_tile "left" "1") (set_tile "left" "0"))
		(if up (set_tile "up" "1") (set_tile "up" "0"))
	)
	(progn
	(setq x_off 0
		y_off 0
		x_scale 200
		y_scale 200
		angs 0)
	(set_tile "x_scale" "0")
	(set_tile "y_scale" "0")
	(set_tile "x_off" "0")
	(set_tile "y_off" "0")
	(set_tile "angs" "0")
	(set_tile "left" "1")
	(set_tile "up" "1")
	(setq flag_init T)
	)
		
	)
	
)

(defun wh_col (do )
	(cond 
        (
            (= do 10)
		(get_value_col 1 (get_tile "x_scale"))
		(get_value_col 2 (get_tile "y_scale"))
		(get_value_col 3 (get_tile "x_off"))
		(get_value_col 4 (get_tile "y_off"))
		(get_value_col 5 (get_tile "angs"))
		(get_value_col 6 (get_tile "left"))
		(get_value_col 7 (get_tile "up"))
		
			)  	;;;
        (
            (= do 9) 
		
		(setvar "osmode" 33) 	
            (setq pt  (getpoint "\ninput point:"))
		(setvar "osmode" 0) 	
		)  	
		)
)
;;
(defun get_value_col (num value)
	(setq val value)
	(cond 	((= num 1)
		(setq x_scale (nth  (atoi value  )  x_scalelst )) )
		((= num 2)
		(setq y_scale (nth  (atoi value  )  y_scalelst )) )
		((= num 3)
		(setq x_off (nth  (atoi value  )  x_offlst )) )
		((= num 4)
		(setq y_off (nth  (atoi value  )  y_offlst )) )
		((= num 5)
		(setq angs (nth  (atoi value  )  anglst )) )
		((= num 6)
		(if (zerop (atoi value)) 
			(setq left nil) (setq left T)) )
		((= num 7)
		(if (zerop (atoi value)) 
			(setq up nil) (setq up T)) )

)
)
;;;****************

;;;***********8888888
(defun c:ax( / os  pt1 pt2 off offpt ang ptold)
		(setq os (getvar "osmode"))
		(setvar "osmode" 0)
	(setq pt1 (getpoint "\ninput point from:")
		pt2 (getpoint pt1 "\ninput point to:"))
	(setq ang (angle pt1 pt2)
		ang (+ ang (* 0.5 pi)) )
	
	(set_layer "axis")
	(line pt1 pt2)
	(while (setq off (getint "\ninput offset:"))
		(setq offpt (polar '(0.0 0.0 0.0 ) ang off))
		(setq ptold pt1 )
		(setq pt1 (mapcar '+ pt1 offpt)
			pt2 (mapcar '+ pt2 offpt))
		(set_layer "dim")
		(dim_hole ptold pt1)
		(set_layer "axis")
		(line pt1 pt2)
		)
	(setvar "osmode" os)
	)
;;
(defun dim_hole (pt1 pt2 / ptref ang )
(setq ang (angle pt1 pt2))
	(if (and (> ang (* 0.75 pi))
			(< ang (* 1.75 pi)) )
		(setq ang (+ ang pi))
		)
	(if archi_scale nil 
		(setq archi_scale (getint "\input draw scale:")) )
	(setq ptref (polar pt1 (+ ang (* 0.5 pi))
				(* archi_scale 30) ))
	(dim pt1 pt2 ptref)
);;
;;************

(DEFUN DIM_HIGH (PT1 flag / X Y Z blkna h sca OS)	
	(setvar "FILEDIA" 0)
	(SETVAR "ATTDIA" 0)
	(SETVAR "CMDDIA" 0)
	(SETQ OS (GETVAR "OSMODE" ))
	(SETVAR "OSMODE" 0)
	(setq y (cadr pt1))
	(SETQ Y (* Y 1.00))
	(cond ((= (strcase flag nil) "L")
		(setq blkna "dim-lh"))
		((= (strcase flag nil) "R")
		(setq blkna "dim-rh"))
	)
	(if archi_scale nil
	(setq archi_scale (getint "\ninput drawing scale:")) )
	(setq sca (* 4.2 archi_scale))
	(setq ang 0)
	(IF (ZERop y )
		(setq h " %%p0.000")
	(setq h (rtos (* y 0.001) 2 3)) )
	
	(command "insert" blkna pt1 sca sca ang h )
	 (setvar "FILEDIA" 1)
	 (SETVAR "ATTDIA" 1)
	 (SETVAR "CMDDIA" 1)
	(SETVAR "OSMODE" OS)
	(TERPRI)
)

;
(defun c:dh_r ()
	(dim_high (getpoint "\ninput pt:") "r")
)


;
(defun c:dh_l ()
	(dim_high (getpoint "\ninput pt:") "l")
)
;;;
(defun copy (ss / dn cmd os INDEX )
	(setq os (getvar "osmode"))
	(setvar "cmdecho" 0)
	(setvar "osmode" 0)
	(setvar "cmddia" 0)
	(setvar "attdia" 0)
	;;(setvar "filedia" 0)
	(setq dn (strcat (getvar "DWGPREFIX") "TEMP.DWG"))
	(princ dn)
	(princ "\n\n")
	(IF (findfile dn )
	(PROGN	 
	(command "wblock" dn    "Y"  "" '(0.0 0.0 0.0 ) ss "" ) 
	
	) ;;
	(PROGN

	(command "wblock" dn  "" '(0.0 0.0 0.0 )  ss "") 
	
	);;PROGN
	)
	
	;;(command "undo" "")
	(setvar "cmdecho" 1)
	(setvar "osmode" os)
	(setvar "cmddia" 1)
	(setvar "attdia" 1)
	(setvar "filedia" 1)
	(princ )
)
;;;
(defun copy_TO (PT ss / dn cmd os INDEX )
	(setq os (getvar "osmode"))
	(setvar "cmdecho" 0)
	(setvar "osmode" 0)
	(setvar "cmddia" 0)
	(setvar "attdia" 0)
	;;(setvar "filedia" 0)
	(setq dn (strcat (getvar "DWGPREFIX") "TEMP.DWG"))
	(princ dn)
	(princ "\n\n")
	(IF (findfile dn )
	(PROGN	 
	(command "wblock" dn    "Y"  "" PT ss  ) 
	
	) ;;
	(PROGN

	(command "wblock" dn  "" '(0.0 0.0 0.0 )  ss ) 
	
	);;PROGN
	)
	
	
	(setvar "cmdecho" 1)
	(setvar "osmode" os)
	(setvar "cmddia" 1)
	(setvar "attdia" 1)
	(setvar "filedia" 1)
	(princ )
)
;;;

(defun PASTE (/ fname cmd os dn )
	(setq os (getvar "osmode"))
	(setvar "cmdecho" 0)
	(setvar "osmode" 0)
	;;(setvar "cmddia" 0)
	(setvar "filedia" 0)
	(setvar "attdia" 0)
	(setq fname (strcat  (getvar "DWGPREFIX") "TEMP.DWG"))
	(setq dn (strcat "*" (getvar "DWGPREFIX") "TEMP.DWG"))
	 (IF (findfile fname )
		 
	(command "insert" dn '(0.0 0.0 0.0 ) 1 0   ) 
	 
	)
	(setvar "cmdecho" 1)
	(setvar "osmode" os)
	(setvar "filedia" 1)
	(setvar "cmddia" 1)
	(setvar "attdia" 1)
)
;;

;;

(defun per ( / t_lst a_lst
		per_dist per_ang flag_init
		angLst 
		val_dist sld_dist ang)
	(setq anglst (list "0"   "90"   "180"   "270"  ))
        (setq t_lst '(		"sld_dist"
			"val_dist"
			;; "list_ang"
			"mat_ang"
			"accept"
			))
	(setq a_lst '(	"(get_value_per 1 $value)"
			"(get_value_per 1 $value)"
			;; "(get_value_per 3 $value)"
			"(get_value_per 4 $value)"
			"(done_dialog 1)" ))
	;;
	(ldcl_ai "c:/archiai/dcl/ai" "per" t_lst a_lst
	init_per wh_per)
	
	(SETVAR "FILEDIA" 1)
(SETVAR "CMDDIA" 1 )
(SETVAR "ATTDIA" 1)
(strcat "@"  val_dist "<"  ang  )
	
)

;;
(defun init_per( / a)
(if flag_init
	
	
	(progn
		
		
	);;;if  init
	(progn
	(setq val_dist "0")
	(setq ang "0")
	(set_tile "val_dist" "0")
	(setq flag_init T)
	);;; if not init
		
	)
	
)
(defun wh_per( do / a)



	(setq a nil )
)

(defun get_value_per ( num val / r s )
	(cond ((= num 1)
		(setq val_dist  val)
		;;(setq r (rem val 50))
		;;(setq s  (- val r ))
		(set_tile "val_dist" val)
		
		)
	((= num 2)
		(setq val_dist  val)
		(set_tile "sld_dist" val)
		
		)
	;;((= num 3)
		
	;;	(setq ang (nth (atoi val) anglst))
		
	;;	)
	((= num 4 )
		
		(setq ang (nth (atoi val) anglst))
		
		)
	)
);;
(defun C:dim_new()
	(set_layer "dim")
	(COMMAND "dim")
)
(defun c:va ()
	(command "view" "r" "va" )
)
(defun c:rectang(/ pt1 pt2 pt3 pt4 x1 y1 x2 y2)
	(setq pt1 (getpoint "\ninput first point"))
		(setq pt3 (getcorner  pt1 "\ninput first point"))
	(setq x1 (car pt1 ) y1 (cadr pt1) 
		x2 (car pt3 ) y2 (cadr pt3) )
	(setq pt2 (list x1 y2 (caddr pt1))
		pt4 (list x2 y1 (caddr pt1)))
(pline (list pt1 pt2 pt3 pt4 pt1))

)
;;


;;
(defun c:aream (/ temp a )
	(setq a (car (entsel)))
   (command "area" "o" a)
	(setq temp (* 0.000001 (getvar "area")) )
	(rtos temp 2 2)
)
;;;

;;;
(defun c:marea ()
( rtos 
(marea (ssget '((-4 . "<or")( 0 . "lwpolyline")
		( 0 . "polyline")
		(-4 . "or>") )
		))  2 2 )
)

(defun c:dim_area_perim( / ent1 temp a p ta tp pt pt1 pt2 )
	(princ "\nselect a polyline")
	(setq ent1 (car (entsel)))
	(setq temp (get_area_perim ent1))
	(setq a (car temp)
		p (cadr temp))
	(if archi_scale
			nil
		(setq archi_scale (getint "\ninput draw scale:")) )
	(setq a (* a  0.000001)
		p (* p  0.001))
	(setq pt (getpoint "\n input a point"))
	(setq pt1 (mapcar '+ pt (list 0.0 (* archi_scale 3.0) 0.0))
		pt2 (mapcar '+ pt (list 0.0 (* archi_scale -3.0) 0.0))
	 )
	(setq ta (rtos a 2 2)
		tp (rtos p 2 2))
	(setvar "textsize" (* 3 archi_scale))
	(text pt1 ta)
	(text pt2 tp)
)
;;
(defun c:da1 ( / ent1 temp a p ta tp pt pt1 pt2 )
	(princ "\nselect  polylines")
	 
	(setq a (marea  (ssget '((-4 . "<or")( 0 . "lwpolyline")
		( 0 . "polyline")
		(-4 . "or>") )
		)
	))
	
	(if archi_scale
			nil
		(setq archi_scale (getint "\ninput draw scale:")) )
	
	(setq pt (getpoint "\n input a point"))
	
	(setq ta (rtos a 2 0) )
	(SETQ ta (strcat ta "m%%147%%1452%%146%%148" ))
	(setq pt1 (mapcar '+ pt (list  (* archi_scale 2.8 (strlen ta)) 				archi_scale 0.0)))
	
	 
	(setvar "textsize" (* 4 archi_scale))
	(text pt ta)
	
)


;;	
(defun c:da2 ( / ent1 temp a p ta tp pt pt1 pt2 )
	(princ "\nselect  polylines")
	 
	(setq a (marea  (ssget '((-4 . "<or")( 0 . "lwpolyline")
		( 0 . "polyline")
		(-4 . "or>") )
		)
	))
	
	(if archi_scale
			nil
		(setq archi_scale (getint "\ninput draw scale:")) )
	
	(setq pt (getpoint "\n input a point"))
	
	(setq ta (rtos a 2 2) )
	(SETQ ta (strcat ta "m%%147%%1452%%146%%148" ))
	(setq pt1 (mapcar '+ pt (list  (* archi_scale 2.8 (strlen ta)) 				archi_scale 0.0)))
	
	 
	(setvar "textsize" (* 4 archi_scale))
	(text pt ta)
	
)


;;
(defun c:floor(/ pt1 pt2 pt3 pt4 pt1a pt2a pt3a pt4a  x1 y1 x3 y3 high )
	(setq pt1 (getpoint "\ninput first point:") 
		
		pt3 (getcorner  pt1  "\ninput second point:")
		)
 	;;(setq high (getint "\ninput height:"))
	(SETQ HIGH 0)
	(setq x1 (car pt1 ) y1 (cadr pt1 ) 
		x3 (car pt3 ) y3 (cadr pt3 ) )
	(setq pt1 (list x1 y1 high)
		 pt2 (list x3 y1 high)
		 pt3 (list x3 y3 high)
		 pt4 (list x1 y3 high) )
	(setq high (- high 100))
	;;(setq pt1a (list x1 y1 high)
	;;;;	 pt2a (list x3 y1 high)
	;;	 pt3a (list x3 y3 high)
	;;	 pt4a (list x1 y3 high) )
	(set_layer "floor")
	(PLINE (LIST pt1 pt2 pt3 pt4 PT1))
	;;(3dface pt1a pt2a pt3a pt4a )
)



(defun c:wall_out (/ pt1 pt2 pt3 pt4 pta ptb ang hwid flag )
	(setq pta (getpoint "\ninput first point:") 
		ptb (getpoint  pta "\ninput second point:") )
	(setq ang (angle pta ptb ))
	(if archi_wallwid  nil
	 (setq archi_wallwid (getint "\ninput archi wall wide :")) )
	(setq hwid (* 0.5 archi_wallwid))
	(if (> (abs (rem ang pi ) ) 0.001 ) 
		(setq flag t) (setq flag nil))
	(set_layer "wall_out")
	(if flag (setq pt1 (mapcar '+  pta (list hwid 0.0 0.0 )) 
			pt2 (mapcar '- pta (list hwid 0.0 0.0 )  ) 
			pt3 (mapcar '- ptb (list hwid 0.0 0.0 )   ) 
			pt4 (mapcar '+ ptb (list hwid 0.0 0.0 )   ) )
		(setq pt1 (mapcar '+  pta (list  0.0 hwid 0.0 )   ) 
			pt2 (mapcar '- pta (list  0.0 hwid 0.0 )   ) 
			pt3 (mapcar '- ptb  (list  0.0 hwid 0.0 )   ) 
			pt4 (mapcar '+ ptb (list  0.0 hwid 0.0 )   ) )	
		)
	(pline (list pt1 pt2 pt3 pt4 pt1))	
		)



(defun c:dim_note (/ pt1 pt2 pt3 txt sca ptt ang )
	 (if archi_scale 
        (setq sca archi_scale)	
	(progn
        (setq sca 
            (getint "\ninput scale:") 
		archi_scale sca   )    )
		)

	(setq pt1 (getpoint "\ninput first point:")
		 pt2 (getpoint pt1 "\ninput second point:")
		pt3 (getpoint pt2 "\ninput third point:"))
	
	(set_layer "dim_note")
	(arrow pt2 pt1 (* 0.5 sca ))
	(line pt2 pt3 )
	(setq txt (getstring "\ndimension:"))
	(setq ang (angle pt2 pt3)
		ptt (polar pt2 (+ (* 0.5 pi) ang)
				(* sca 1.2)  )
		)


	(text ptt txt)

)
	;;



(defun c:hline(/ pt1 pt2 )
	(grdraw (setq pt1 (getpoint  ":\ninput first point")) 
		(getpoint pt1  ":\ninput first point" ) 1 1 )
)
;;;
(defun c:smg ( / ent ss condition  type name lay temp);; smart get function as showed by example
	(princ "\nshow me a example")
	(setq ent (ssname  (ssget ) 0) )
	(redraw ent 1)
	(setq temp (entget ent))

	(setq type (get 'temp 0)
		 lay (get 'temp 8 ))
		(putprop 'condition type 0)	
		(putprop 'condition lay 8)	
	(if (= type "INSERT")
	(PROGN
		(SETQ NAME (get 'temp 2))	
		(putprop 'condition name 2)	
		(SSGET condition)
		)
	 
		;;(SETQ NAME (get 'temp 2))	
		;;(putprop 'condition name 2)	
		(SSGET condition)
		 )
)

(defun c:aud ()
	(command "audit" "y")
	(command "purge" "a" "" "n")
)


(defun c:tti ()
	(if (zerop (getvar "TILEMODE")) (SETVAR "TILEMODE" 1) (SETVAR "TILEMODE" 0))
)
;;;;
(defun c:zp () (command "zoom" "p"))
;
(DEFUN C:D() (SET_layer "dim") (command "dim"))
(DEFUN C:Dd() (SET_layer "dim_detail") (command "dim"))
;
(defun c:door () (set_layer "door"))
(defun c:windows () (set_layer "windows"))
(defun c:floor () (set_layer "floor"))
(defun c:wall () (set_layer "wall"))

(defun c:+() (command "'zoom" "2x"))
(defun c:-() (command "'zoom" "0.5x"))

;;
( DEFUN  xarray ( ss  x y n / str pt1 pt2 )
	(setq pt1 '( 0.0 0.0 0.0 ))
	(setq pt0 '( 0.0 0.0 0.0))
	 (repeat n 
		(setq pt2  
				(mapcar '+ pt1 (list x y 0.0) ) )
	        (command "copy"  ss "" pt0 pt2 )
		(setq pt1 pt2)
			 )
			
)

;;;(LOAD "C:/ARCHIAI/LSP/BLK_UTIL")
(defun ostoggle(  )
	(if (zerop (getvar "osmode" ) )

            (IF osold (setvar "osmode" osold)
			(setvar "osmode" 33) )
             (progn 
		(setq osold (getvar "osmode"))
		(setvar "osmode" 0) 
			);;end progn
			);;end if
)
		



(defun dim_location_pt_ld  ( pt / pt1 pt2 pt3 pta ptb sca )


	 (if archi_scale 
        (setq sca archi_scale)	
	(progn
        (setq sca 
            (getint "\ninput scale:") 
		archi_scale sca   )    )
		);;

	(setq pt1 pt
		 pt2 (polar pt1  (* 0.25 pi) (* sca 12) )
		pt3 (polar pt2  0.0 (* sca 24.0) ) );;
	
	(set_layer "dim_note")
	(arrow pt2 pt1 (* 0.5 sca ))
	(line pt2 pt3 )
	(setq txt  (rtos (* masure_scale  (cadr pt1 )) 2 2 ) )
		(setq txt (strcat "A=" txt))
	(setq pta (mapcar '+ pt2 (list sca sca 0.0) ) )
	
	(text pta txt);;

	(setq txt    (rtos (* masure_scale (car pt1 ) )2 2 ) )
		(setq txt (strcat "B=" txt))
	(setq ptb (mapcar '+ pt2 (list sca  (* sca -7.0 )  0.0) ) )
	
	(text ptb txt)




)

;;
(defun dim_location_pt_lu ( pt / pt1 pt2 pt3 pta ptb sca )


	 (if archi_scale 
        (setq sca archi_scale)	
	(progn
        (setq sca 
            (getint "\ninput scale:") 
		archi_scale sca   )    )
		);;

	(setq pt1 pt
		 pt2 (polar pt1  (* 1.75 pi) (* sca 12) )
		pt3 (polar pt2  0.0 (* sca 24.0) ) );;
	
	(set_layer "dim_note")
	(arrow pt2 pt1 (* 0.5 sca ))
	(line pt2 pt3 )
	(setq txt  (rtos (* masure_scale  (cadr pt1 )) 2 2 ) )
		(setq txt (strcat "A=" txt))
	(setq pta (mapcar '+ pt2 (list sca sca 0.0) ) )
	
	(text pta txt);;

	(setq txt    (rtos (* masure_scale (car pt1 ) )2 2 ) )
		(setq txt (strcat "B=" txt))
	(setq ptb (mapcar '+ pt2 (list sca  (* sca -7.0 )  0.0) ) )
	
	(text ptb txt)




)
;;

(defun dim_location_pt_ru  ( pt / pt1 pt2 pt3 pta ptb sca )


	 (if archi_scale 
        (setq sca archi_scale)	
	(progn
        (setq sca 
            (getint "\ninput scale:") 
		archi_scale sca   )    )
		);;

	(setq pt1 pt
		 pt2 (polar pt1  (* 1.25 pi) (* sca 12) )
		pt3 (polar pt2  0.0 (* sca -24.0) ) );;
	
	(set_layer "dim_note")
	(arrow pt2 pt1 (* 0.5 sca ))
	(line pt2 pt3 )
	(setq txt  (rtos (* masure_scale  (cadr pt1 )) 2 2 ) )
		(setq txt (strcat "A=" txt))
	(setq pta (mapcar '+ pt3 (list 0.0 sca 0.0) ) )
	
	(text pta txt);;

	(setq txt  (rtos (* masure_scale  (car pt1 ) ) 2 2 ) )
		(setq txt (strcat "B=" txt))
	(setq ptb (mapcar '+ pt3 (list 0.0  (* sca -7.0 )  0.0) ) )
	
	(text ptb txt)




)


(defun dim_location_pt_rd  ( pt / pt1 pt2 pt3 pta ptb sca )
	
	 
	 (if archi_scale 
        (setq sca archi_scale)	
	(progn
        (setq sca 
            (getint "\ninput scale:") 
		archi_scale sca   )    )
		);;

	(setq pt1 pt
		 pt2 (polar pt1  (* 0.75 pi) (* sca 12) )
		pt3 (polar pt2  0.0 (* sca -24.0) ) );;
	
	(set_layer "dim_note")
	(arrow pt2 pt1 (* 0.5 sca ))
	(line pt2 pt3 )
	(setq txt  (rtos (* masure_scale  (cadr pt1 )) 2 2 ) )
		(setq txt (strcat "A=" txt))
	(setq pta (mapcar '+ pt3 (list 0.0 sca 0.0) ) )
	
	(text pta txt);;

	(setq txt  (rtos (* masure_scale  (car pt1 ) ) 2 2 ) )
		(setq txt (strcat "B=" txt))
	(setq ptb (mapcar '+ pt3 (list 0.0  (* sca -7.0 )  0.0) ) )
	
	(text ptb txt)




)


(defun c:dL_ld ()
	(dim_location_pt_ld (getpoint "\ninput point left&down :"))
)

(defun c:dL_ru ()
	(dim_location_pt_ru (getpoint "\ninput point right&up :"))
)

(defun c:dL_lu ()
	(dim_location_pt_lu (getpoint "\ninput point left&up :"))
)

(defun c:dL_rd ()
	(dim_location_pt_rd (getpoint "\ninput point right&down :"))
)

;;
(load "/archiai/lsp/UTIL/archi/m_block.lsp")
;;
(defun get_layer_list ( / res temp lana  )
	(setq temp (tblnext "layer" t ))
		(setq lana (get 'temp 2))
		(setq res (cons lana res))
	(while (setq temp (tblnext "layer"))
		(setq lana (get 'temp 2))
		(setq res (cons lana res))
	)
	(acad_strlsort  res)
)

(defun get_block_list ( / res temp lana  )
	(setq temp (tblnext "block" t ))
		(setq lana (get 'temp 2))
		(setq res (cons lana res))
	(while (setq temp (tblnext "block"))
		(setq lana (get 'temp 2))
		(setq res (cons lana res))
	)
	(acad_strlsort res)
)
;;;
(load "/archiai/lsp/util/archi/arselect.lsp")
(load "/archiai/lsp/util/archi/area.lsp")
(LOAD "/ARCHIAI/LSP/EDL.LSP")
(LOAD "/ARCHIAI/LSP/fix.LSP")
(LOAD "/ARCHIAI/LSP/dimen.LSP")
;;;



(defun arucs (entline / pt1 pt2 ang pt3 temp  dist )
	(setq temp (entget entline))
		(setq pt1 (get 'temp 10))
		(setq pt2 (get 'temp 11))
		(setq dist (distance pt1 pt2))
		(setq ang (angle pt1 pt2))
		(setq ang (+ (* -0.5 pi ) ang))
		(setq pt3 (polar pt1 ang dist))
		(setq pt1 (trans pt1 0 1 )
			pt2 (trans pt2 0 1 )
			pt3 (trans pt3 0 1 ) )
		(command "ucs" "3" pt1 pt3 pt2)
)

(DEfun c:arucs ()
	(PRINC "\N SELECT A LINE")
	(arucs (car (entsel)))
)



(defun c:dim_length ( / ent temp pt1 pt2 pt txt dist )
	(setq ent (car (entsel))
		temp (entget ent ))
	(setq pt1 (get 'temp 10)
		pt2 (get 'temp 11))
	(setq dist (distance pt1 pt2)
		pt (midpoint pt1 pt2))
	(setq txt (rtos dist 2 2))
	(text pt txt)
		)

;;
(defun c:divideline ( / lineent pt1 pt2 pt3 temp )
	(setq lineent (car (entsel)))
	(setq  temp (entget lineent ))
	(if (equal (get 'temp 0 ) "LINE")
		(PROGN 
		   (setq pt1 (get 'temp 10 )
			 pt2 (get 'temp 11))
		   (setq pt3 (midpoint pt1 pt2))
			(line pt1 pt3)
			(line pt3 pt2)
		(entdel lineent)
			);END PROGN 
		);END IF
)

;
;;
(defun c:chxy( / ent temp str slen a)
  (setq ent (car (entsel)))
	
(setq temp (entget ent))
	(setq str (get 'temp 1))
	(setq slen (strlen str))
		(setq a (substr str 1 1))
		(cond ((= a "X") (setq str (strcat  "Y" (substr str 2 (1- slen) )) ) )
			((= a "Y") (setq str (strcat  "X" (substr str 2 (1- slen) )) ) )
			(t nil))
       (putprop 'temp str 1)
	(entmod temp)
	(entupd ent)

);;;
(defun c:exfullscreen()
(acet-fscreen-toggle)
)
;;
(defun c:hideent (/ ss)	
	(setq ss (ssget))
	(command "chprop" ss "" "la" "hide" )
)
;;
(load "c:\\archiai\\lsp\\blk_util")

(defun gettextent ( /  ssold  a x index)
		(setq ssold (ssget))
		(setq index 0) (setq ss (ssadd))
	(repeat (sslength ssold)
			(setq a (ssname ssold index))
				(setq x (entget a))
			(if (zerop (atof (get 'x 1)))
				
				(setq ss (ssadd a ss))  nil )
		(setq index (1+ index))
		)
		(setq index 0)
		(repeat (sslength ss)
			(setq a (ssname ss index))
				(setq x (entget a))
			(putprop 'x "LAYER1" 8)
			(ENTmod x)
				(entupd a)
		(setq index (1+ index))
		)
)

(defun c:pcopy (/ ss pt0 ptlist  blkss pt1 ent index temp  OSMODE 
)
	(SETQ osmode (getvar "OSMODE"))
	(SETVAR "OSMODE" 0)

     (setq ss (ssget))
  
  
	(setq ent (entsel)) 
	(setq temp (entget (car ent)))
        (setq pt0 (get 'temp 10))
	(setq pt0 (trans pt0 0 1))
;;;
       (setq blkss (ssget '(( 0 . "insert"))) )
	(setq index 0)
	(while (setq ent (ssname blkss index)) 
			(setq temp (entget ent))
			(setq pt1 (get 'temp 10))
				(setq pt1 (trans pt1 0 1))
		(command "copy" ss "" pt0   pt1 )
			(setq index (1+ index))


        );;end while 
	(SETVAR "OSMODE" OSMODE)
)

;;
(defun c:bprocess()

(ssget  '(( 8 . "Hatch")))
(ai_draworder "_b")
(ssget   '(( 0 . "HATCH")))
(ai_draworder "_b")
(ssget  '(( 8 . "WALL")))
(ai_draworder "_f")

)
;;
(defun c:zeroy-line (/
 entss ent pt1 pt2 y1 index  temp 
)
 (setq index 0)

 (setq entss (ssget '(( 0 . "line"))) )
 (repeat (sslength entss)
     (setq ent (ssNAME entss index))
	(setq temp (entget ent))
	(setq pt1 (get 'temp 10))
	(setq pt2 (get 'temp 11))
	(setq  y1 (cadr pt1))
	(setq pt2 (list (car pt2) y1 0.0 ) )
	(PUTPROP 'TEMP PT2 11)	
	(ENTMOD TEMP)
	(ENTUPD ENT)
	(setq index (1+ index))
)
)


(defun c:cut(/ temp ent txt len index  ss)
		(setq index 0)
	(setq ss (ssget '(( 0 . "text"))))
	(repeat (sslength ss)
	
	(setq ent (ssname ss index))
	(setq temp (entget ent))
	(setq txt (get 'temp 1))
	(setq len (strlen txt))
		(setq txt (substr txt 1 (- len 22)) )
		(setq txt (strcat txt "ƽ"))
	(putprop 'temp txt 1)
	(entmod temp)
	(entupd ent) 
		(setq index (1+ index))
	);;;end 
)
;;;
;;;;layer tools
;;;
(defun layerlist ( / temp X )
	(setq x (tblnext "layer"  t))
	(setq x (get 'x 2))
	(setq temp (cons x temP))
	(while (setq x (tblnext "layer" ) )
		(setq x (get 'x 2))
		(setq temp (cons x temP))
		)
(princ temp)
)
;;;


;;
(defun selectlalist (ss / ent entlist laname lalist index )
	(setq index 0 lalist nil )	
		(repeat (sslength ss)
		(setq ent (ssname ss index))
		(setq entlist (entget ent))
		(setq laname (get 'entlist 8))
		(if (member laname lalist )
			nil 
			(setq lalist (cons laname lalist))
		);;end if
		(setq index (1+ index))
		);;end repeat 
     (reverse lalist)
)	
;;;
(defun c:lockunselect (
/ xlalist xlaname xselectlalist x xlaent xlaentlist lastatus
)

		(setq xlalist (layerlist )
		 xselectlalist (selectlalist (ssget))
					)
		(while  xlalist 
			(setq x (car xlalist))
			(if (member x xselectlalist )
				nil 
				(progn 
				(setq xlaent (tblobjname "layer" x))
					
				(setq xlaentlist (entget xlaent))
					(if (or (minusp (get 'xlaentlist 62 ))
					(= 1 (get 'xlaentlist 70 )) )
					nil 
					(progn
				 (putprop 'xlaentlist 4 70)
				 (entmod xlaentlist)
					));;end progn if
							
				);;end progn
			);; end if 

			(setq xlalist (cdr xlalist ))
			);;end while 
		
)

(defun c:unlockall (
/ xlalist xlaname  x xlaent xlaentlist 
)

		(setq xlalist (layerlist )
		
					)
		(while  xlalist 
			(setq x (car xlalist))
			
				(setq xlaent (tblobjname "layer" x))
					
				(setq xlaentlist (entget xlaent))
					(if (or (minusp (get 'xlaentlist 62 ))
					(= 1 (get 'xlaentlist 70 )) )
					nil 
					(progn
				 (putprop 'xlaentlist 0 70)
				 (entmod xlaentlist)
					));;end progn if
							
				
			(setq xlalist (cdr xlalist ))
			);;end while 
		
)				
   
;;
(defun c:lla ( / temp  x )
	(setq temp (layerlist))
	(setq x (car temp))
	(setq pt (getpoint))
	(while x 
		(set_layer x)
		(text pt  x )
		(setq temp (cdr temp))
		(setq x (car temp))
		(setq pt (mapcar '+ pt (list 0.0 (* archi_scale 10) 0.0 ) ))
						
		)
		)
	
;;

;;(arxload "c:\\tangent\\tarch5\\sys\\tch_kernal.arx")


;;(arxload "c:\\tangent\\tarch5\\sys\\tch_initstart.arx")

